﻿//※【未完】＞ＣＳＶファイル開き中で再試行すると「適用」ボタンがアクティブにならない。
_protected	= false;
//※↑この値が「true」なら編集不可：「false」なら編集可
/**

///	規定色を対応レイヤーに適用するスクリプト

	制作：彩藤神楽	(http://www.re-sonance.com/)


	Copyright (C) 2007-2008 Saitoh Kagura, All Rights Reserved.

 */

const SCRIPT_TITLE	= "色管理";
const VERSION		= "0.1.00";


///-------------------------------------------------------------
///	外部スクリプトファイル読み込み
//--------------------------------------------------------------
#include "./lib/Resonance.jsxinc"
#include "./lib/ScriptUtil.jsxinc"
#include "./lib/ColorUtil.jsxinc"
#include "./lib/LayerUtil.jsxinc"
#include "./lib/LayerCompUtil.jsxinc"
#include "./lib/FileUtil.jsxinc"
#include "./lib/StringUtil.jsxinc"
#include "./lib/CSVConnector.jsxinc"
#include "./lib/ConfigDialog.jsxinc"


///-------------------------------------------------------------
///	グローバル
//--------------------------------------------------------------

//--> 基礎準備
#target photoshop
app.bringToFront();
const NEW_LINE	= Resonance.NEW_LINE;
const NEW_LINE2	= NEW_LINE + NEW_LINE;
const INDENT	= Resonance.INDENT;
_resonance		= new Resonance(SCRIPT_TITLE, VERSION);

//> 色設定ファイル
const COLOR_FILE_REG		= /(色|カラー|color).*\.(csv|txt|text)$/i;
const EXCLUDED_NAME_REG		= /!/;
const COLOR_WILD_FILTER_REG	= /&/;
const COLOR_FILE_PREFIX_REG	= /(色|カラー|color)/i;
const COLOR_EXTENSION_REG	= /\.(csv|txt|text)$/i;
const DEFAULT_CSV_TEXT		= "名前,ベース,,," + NEW_LINE + ",,,," + NEW_LINE;
const DEFAULT_FILE_PREFIX	= "[色設定]-";
const EXTENSION_LIST		= [".csv", ".txt", ".text"];
const DEFAULT_EXTENSION		= EXTENSION_LIST[0];
const COLOR_TRANS_SPLITER	= ":";

//> 各種定数
const FILL_PREFIX			= "=";	//規定色で塗り潰すレイヤーの接頭辞
const FILL_REG_PREFIX		= "[=＝][ 　]*";
const EXTRACT_FIRST_KEY_REG	= /\|.*/;
const REG_DELIMITER			= "|";
const REG_DELIMITER_REG		= /\|.*/;
const NAME_INDEX			= 0;
const BASE_INDEX			= 1;
const OPTION_ENABLE_REG		= /[:|]/;
const OPTION_SELECT_REG		= /^[^:]*[:]?/;
const OPTION_TRANSFORM_REG	= /^[^|]*[|]?/;
const OPTION_FILTER_REG		= /[:|].*/;

//> イベントアクション用定数
const ACTION_PARENT_LAYER_SET	= _resonance.getEventActionName("親レイヤーセットを作成した時");
const ACTION_NEW_PARENT_LAYER	= _resonance.getEventActionName("親レイヤー作成");
const ACTION_NEW_CHILD_LAYER	= _resonance.getEventActionName("子レイヤー作成");
const ACTION_FILL_LAYER			= _resonance.getEventActionName("レイヤー塗り潰し");
const ACTION_FILL_LAYER_PREFIX	= _resonance.getEventActionName('"');
const ACTION_FILL_LAYER_SUFFIX	= '"が塗り潰された時';
const ACTION_NEW_PARENT_LAYER_SUFFIX	= '"の親レイヤーセットが作成された時';
const ACTION_NEW_LAYER_SUFFIX	= '"が作成された時';
const ACTION_PARENT_DELIMITER	= "/";
const ACTION_PREFIX_HEAD		= "^";	//※【未完】＞レイヤー作成時しか効かない

//> テンプレート用定数
const TPL_LAYER_SET_TAG			= "<template>";
const TPL_LAYER_SET_REG			= /<template>/i;
const TPL_NAME_REG				= /<name>/ig;
const TPL_BASE_REG				= /<base>/ig;
const TPL_X_MOVE_REG			= /(<template>|[ 　]*y[-+]\d+|[ 　]*x[+]?)/ig;
const TPL_Y_MOVE_REG			= /(<template>|[ 　]*x[-+]\d+|[ 　]*y[+]?)/ig;
const DELETE_NAME_REG			= / のコピー.*/g;

//> 色編集用定数
const JOIN_COMMA				= ", ";
const SPLIT_COMMA_REG			= /[ 　]*,[ 　]*/;
const MAX_EDIT_COLOR			= 8;

//> 確認メッセージ
const CONFIRM_SUFFIX			= NEW_LINE2 + "よろしいですか？";
const CONFIRM_CHANGE_KEYS		= "色設定の種類名を更新します。" + NEW_LINE + "色設定ファイルが現在の設定に基づいて更新されます。" + CONFIRM_SUFFIX;
const CONFIRM_CHANGE_FILE		= "編集する色設定ファイルを変更します。" + NEW_LINE + "色設定ファイルは現在の設定に基づいて更新されます。" + CONFIRM_SUFFIX;
const CONFIRM_CREATE_LAYERS		= "色設定表に基づいた新規レイヤーを生成します。" + NEW_LINE2 + "生成先は【 ";
const CONFIRM_CREATE_BY_TPL		= "色設定表と【" + TPL_LAYER_SET_TAG + "】内の構成に基づいて色見本を新規に生成します。" + NEW_LINE2 + "生成先は【 ";
const CONFIRM_FILL_LAYERS		= '色設定表に基づき、"' + FILL_PREFIX + '"から始る名前を持つ対応レイヤーを塗り潰します。' + NEW_LINE2 + '対象となるのは【 ';
const CONFIRM_START_SUFFIX		= " 】内です。" + CONFIRM_SUFFIX;
const TITLE_RESULT_FILL			= "レイヤー塗り潰し完了";
const TITLE_RESULT_CREATE		= "レイヤー生成完了";
const TITLE_RESULT_TPL			= "色見本生成完了";
const RESULT_CREATE_LAYERS		= "色設定表に基づいてレイヤーを生成しました。";
const RESULT_NOT_CREATE_LAYERS	= "色設定表が空なのでレイヤーは生成されませんでした。";
const RESULT_FILL_LAYERS		= "色設定表に基づいてレイヤーを塗り潰しました。";
const RESULT_NOT_FILL_LAYERS	= "対応するレイヤーがありませんでした。";
const RESULT_BY_TPL				= "テンプレートに基づいて色見本レイヤーを生成しました。";

//> エラーメッセージ
const ERROR_CSV_NOT_SAVED		= "色設定ファイルを更新できませんでした。";

//> グローバルに扱う設定系オブジェクト
var _config;

//> 設定データの標準値
var _configData	= {};

//> 表示スタック
const INDEX_DEFAULT_STACK	= 0;
_configData.groupData	= {
	 Main		: "色設定表"
	,Edit		: "色編集"
	,Config		: "詳細設定"
};

//> 設定データ表示テキスト
_configData.infoData	= {
	 Main	: {
		 _colorFilesSelector: "ファイル:"
		,_FileFilter		: "ファイル名フィルタ:"
		,_browserInfo		: "色設定ファイルが存在するフォルダを選択してください。"
	}
	,Edit	: {
		 _colorFileName		: "ファイル:"
		,_colorKeysInfo		: "種類名:"
		,_foregroundColor	: "描"
		,_backgroundColor	: "背"
	}
	,Config	: {
		 SubFolderDepth		: [0, 1, 2, 3, 4, 5, 6, 7, 8]
		,_SubFolderDepth	: "色設定ファイル検索サブフォルダ最大深度:"
		,_SubFolderDepthNote: "　※深くまで検索する設定にすると、起動が遅くなる事があります。"
		,AutoFilter			: "起動時に前回の色抽出状況を再現(&F)"
		,IntoLayerSet		: "グループ毎にレイヤーセットを生成(&L)"
		,CreateLayerSetAmount	: [1, 2, 3, 4, 5, 6, 7, 8]
		,_CreateLayerSetAmount	: "　これ以上の色数の場合にレイヤーセットを生成する:"
		,UpperCase			: "カラーコードを大文字で表記(&U)"
	}
	,_createLayers			: "レイヤー生成(&C)"
	,_createSampleColors	: "色見本作成(&C)"
	,_fillLayers			: "色設定適用(&F)"
};

//> ヘルプチップ
_configData.helpData	= {
	 Main	: {
		"_FileFilter,FileFilter"	: "正規表現（JavaScript）でマッチする名前の色設定ファイルを抽出します。" +
			NEW_LINE + '末尾で":"（半角コロン）に続けて名前を書くと、それを含む色設定ファイルを自動的に選択するようになります。'
	}
	,Edit	: {
		 _color_code		:  "RGBカラーコードを16進数で記入してください"
		,_foregroundColor	: "描画色のカラーコード("
		,_backgroundColor	: "背景色のカラーコード("
		,_insertColorSuffix	: ")を挿入します"
	}
	,Config	: {
		 "_CreateLayerSetAmount,CreateLayerSetAmount"	: '"0"の場合は常にレイヤーセットを生成します。'
	}
	,_metaTitle		: "ファイル名フィルタデータ"
};

//> 設定データ標準値
_configData.defaultData	= {
	 ScriptTitle	: SCRIPT_TITLE
	,ScriptVersion	: VERSION
	,Main	: {
		 ColorFilePath	: ""
		,ColorFile		: ""
		,FileFilter		: ""
		,ExtractColors	: []
	}
	,Config	: {
		 SubFolderDepth	: 1
		,AutoFilter		: true
		,AutoSave		: false
		,UpperCase		: true
		,IntoLayerSet	: true
		,CreateLayerSetAmount	: 1
	}
};
//> 設定データ最大値
_configData.maxData	= {
};
//> ダイアログ横幅
_configData.widthData	= {
	 Main	: {
		 "_colorList,_colorListKey,_hr,_colorFiles"	: 350
//		,"_colorFiles"	: 260
		,"_up,_down"	: 60
		,FileFilter		: 260
	}
	,Edit	: {
		 "_colorList"	: 160
		,"_colorFileName,_colorKeysInfo"	: 50
		,"_colorFile,_colorKeys"	: 280
		,"_editNameTitle,_editName1,_editName1,_editName2,_editName3,_editName4,_editName5,_editName6,_editName7,_editName8"	: 60
		,"_edit1,_edit1,_edit2,_edit3,_edit4,_edit5,_edit6,_edit7,_edit8"	: 60
		,_editTitle	: 120
		,"_foregroundColor,_backgroundColor"	: 30
	}
	,currentStack	: 100
};
//> ダイアログ縦幅
_configData.heightData	= {
	 Main	: {
		 "_colorList"	: 200
	 }
	,Edit	: {
		 "_colorList"	: 260
	 }
	,currentStack	: 80
};


//--> 本体実行
main();


///-------------------------------------------------------------
///	メインフロー関数
//--------------------------------------------------------------

///{} 本体
function main() {

	//--? 起動時チェック
	try{
		ScriptUtil.inspectDocumentExists();
		ScriptUtil.inspectPhotoshopVersion();
		ScriptUtil.inspectDocumentFormat();
	}catch(e){
		_resonance.showError(e);
		return;
	}

	//--> 現在の描画色を記憶
	ColorUtil.memorizeEditColor();

	//--> 一時記憶用レイヤーカンプが残っていたら全て破棄
	LayerCompUtil.removeLayerComps(activeDocument, _resonance.backupLayerCompName);

	//--> アルファチャンネルの描画色を拾わないようRGBチャンネルを選択
	ColorUtil.selectRGBChannel();

	try{

		mainFlow();

	}catch(e){
		_resonance.showError(e);
	}

	//--> 描画色・背景色を復元
	ColorUtil.rememberEditColor();

	app.bringToFront();

};


///{} メインフロー
function mainFlow() {

	//--> 設定読み込み
	loadConfig();

	//--? 設定ダイアログを表示してキャンセルされなければ一斉処理
	if(_config.show()){

		activeDocument.selection.deselect();

		if(_config.global.isCreated){
			//--> 複数対象レコードを個別に分ける
			_config.global.color_csv.splitSameRecord(NAME_INDEX);
			//--? 生成対象がない場合キャンセル
			if(!_config.global.color_csv.getRows()){
				_config.alertAs(RESULT_NOT_CREATE_LAYERS);
				return;
			}
			var activeLayer	= activeDocument.activeLayer;
			if(activeLayer.typename == "LayerSet" && TPL_LAYER_SET_REG.test(activeLayer.name)){
				//(!) テンプレートからレイヤー生成
				createLayersByTemplate(activeLayer);
			}else if(activeLayer.parent.typename == "LayerSet" && TPL_LAYER_SET_REG.test(activeLayer.parent.name)){
				//(!) テンプレートからレイヤー生成
				createLayersByTemplate(activeLayer.parent);
			}else{
				//(!) レイヤー生成
				createLayers();
			}
		}else{
			//(!) レイヤー塗り潰し
			fillLayers(_config.global.targetParent);
		}

	}

};



///-------------------------------------------------------------
///	ダイアログ設定関数
//--------------------------------------------------------------


///{} 設定読み込み
function loadConfig() {

	//--> XMLデータとダイアログ設定を関連付けるクラスを生成
	_config	= new ConfigDialog(_configData);
	ScriptUtil.tries(_resonance.windowTitle, _config.connectXMLON, _config, [
		 _resonance.configFilePath
		,SCRIPT_TITLE
		,VERSION
	]);

	//--> ダイアログ基本設定
	_config.title	= _resonance.windowTitle;

	_config.global.firstFilter	= _config.data.Main.FileFilter;
	_config.global.edited	= false;

  ///{} ダイアログのレイアウトと設定データの対応を準備する
  _config.prepare	= function(){

	//--> ドキュメント名のオプションを取得して見つかればパターン定義に適用
	var metaData_str	= _resonance.getConfigMetaData();
	if(metaData_str){
		this.data.Main.FileFilter	= metaData_str;
	}

	//--> 対象レイヤーセット
	var targetParent	= LayerUtil.getTargetParentLayer(activeDocument.activeLayer);
	this.global.targetParent	= targetParent;

	var getRegularColorCode	= ColorUtil.getRegularColorCode;
	var UpperCase			= this.data.Config.UpperCase;
	var foreColorCode		= getRegularColorCode(foregroundColor.rgb.hexValue, UpperCase);
	var backColorCode		= getRegularColorCode(backgroundColor.rgb.hexValue, UpperCase)
	var helpForegroundColor	= foreColorCode + this.helpData.Edit._insertColorSuffix;
	var helpBackgroundColor	= backColorCode + this.helpData.Edit._insertColorSuffix;

	/// レイアウト

	const NARROW_SPACE	= ConfigDialog.NARROW_SPACE;
	const BROAD_SPACE	= ConfigDialog.BROAD_SPACE;

	const stack_opt		= this.setOptions({orientation:"column", alignChildren:"left"});
	const column_opt	= this.setOptions({orientation:"column", alignChildren:"left", alignment:"top"});
	const row_opt		= this.setOptions({orientation:"row"});
	const narrowColumn_opt	= this.setOptions({orientation:"column", spacing:NARROW_SPACE});
	const narrowRow_opt	= this.setOptions({orientation:"row", spacing:NARROW_SPACE});
	const edit_opt		= this.setOptions({justify:"right"});
	const foreColor_opt	= this.setOptions({text:this.infoData.Edit._foregroundColor, helpTip:this.helpData.Edit._foregroundColor + helpForegroundColor,width:this.widthData.Edit._foregroundColor});
	const backColor_opt	= this.setOptions({text:this.infoData.Edit._backgroundColor, helpTip:this.helpData.Edit._backgroundColor + helpBackgroundColor,width:this.widthData.Edit._backgroundColor});
	const menu_opt		= this.setOptions({width:this.widthData.currentStack});

	//--> メインウィンドウ生成
	this.create(row_opt);

	//--> メインパネル
	this.addGroup("_stack", column_opt);
	this.addPanel("_stack/_frame", {orientation:"stack", alignChildren:"left"});

	//--> 色設定表パネル
	this.addGroup("_stack/_frame/Main", stack_opt);
		this.addGroup("_stack/_frame/Main/_files", narrowRow_opt);
			this.addText("_FileFilter");
			var filter_etx	= this.addEditText("FileFilter", undefined, "onChangeFileFilter");
		this.addGroup("_stack/_frame/Main/_selector", narrowRow_opt);
			this.addText("_colorFilesSelector");
			this.addButton("_browser", undefined, "onClickCSVBrowser");
			this.ascend();
		var files_ddl	= this.addDropDownList("_colorFiles", undefined, "onChangeCSVList");
		this.addHorizon("_hr");
		var color_etx	= this.addText("_colorListKey");
		var color_lbx	= this.addEditListBox("_colorList", undefined, undefined, undefined, true);
		this.addGroup("_stack/_frame/Main/_edit");
			color_lbx.addUpButton("_up", undefined, "onClickUpDown");
			color_lbx.addDownButton("_down", undefined, "onClickUpDown");
			color_lbx.addInvertButton();
			var extact_btn	= color_lbx.addExtractButton(undefined, undefined, "onClickExtract");
//			extact_btn.visible	= !this.data.quickSelected;	//※【未完】

	//--> 色設定編集パネル
	var editKeys	= [];
	var editCodes	= [];
	var foreButtons	= [];
	var backButtons	= [];
	this.addGroup("_stack/_frame/Edit", stack_opt).enabled	= !_protected;
		this.addGroup("_stack/_frame/Edit/_file", row_opt);
			this.addText("_colorFileName");
			var editFile_etx	= this.addEditText("_colorFile", undefined, "onChangeFile");
		this.addGroup("_stack/_frame/Edit/_keys", row_opt);
			this.addText("_colorKeysInfo");
			var colorKeys_etx	= this.addEditText("_colorKeys", undefined, "onChangeEditKeys");
			this.ascend();
		this.addGroup("_stack/_frame/Edit/_colors", narrowRow_opt);
			var colorEdit_lbx	= this.addEditListBox("_colorList", undefined, "onChangeEditList");
			this.addGroup("_stack/_frame/Edit/_colors/_edit", {orientation:"column", alignChildren:"top", spacing:NARROW_SPACE});
				this.addGroup("_stack/_frame/Edit/_colors/_edit/_title", narrowRow_opt);
					editKeys[0]		= this.addText("_editNameTitle", edit_opt);
					editCodes[0]	= this.addEditText("_editTitle")
					this.ascend();
				this.addSpace();
				for(var i = 1; i <= MAX_EDIT_COLOR; i++){
					this.addGroup("_stack/_frame/Edit/_colors/_edit/_" + i, narrowRow_opt);
						editKeys[i]		= this.addText("_editName" + i, edit_opt);
						editCodes[i]	= this.addEditText("_edit" + i);
						editCodes[i].onChange	= function(){
							this.text	= getRegularColorCode(this.text, _config.data.Config.UpperCase);
						};
						foreButtons[i]	= this.addButton(undefined, foreColor_opt);
						foreButtons[i].colorCode_etx	= editCodes[i];
						foreButtons[i].onClick	= function(){
							this.colorCode_etx.text	= foreColorCode;
						};
						backButtons[i]	= this.addButton(undefined, backColor_opt);
						backButtons[i].colorCode_etx	= editCodes[i];
						backButtons[i].onClick	= function(){
							this.colorCode_etx.text	= backColorCode;
						};
				}
					this.ascend();
				this.addSpace();
		this.addGroup("_stack/_frame/Edit/_colors/_edit/_button", {orientation:"row", alignment:"center"});
			colorEdit_lbx.addApplyButton(undefined, "_addButton", undefined, "onClickColorApply");
			colorEdit_lbx.addRemoveButton("_removeButton", undefined, "onClickColorRemove");

	//--> 詳細設定パネル
	this.addGroup("_stack/_frame/Config", stack_opt);
		this.addGroup("_stack/_frame/Config/_subDepth", row_opt);
			this.addText("_SubFolderDepth");
			this.addDropDownList("SubFolderDepth", undefined, "onChangeSubFolderDepth");
			this.ascend();
		this.addText("_SubFolderDepthNote").enabled	= false;
		this.addCheckBox("AutoFilter");
		this.addCheckBox("IntoLayerSet", undefined, "onChangeIntoLayerSet");
		var notLayerSet_grp	= this.addGroup("_stack/_frame/Config/_notLayerSet", row_opt);
			this.addText("_CreateLayerSetAmount");
			this.addDropDownList("CreateLayerSetAmount");
			this.ascend();
		this.addCheckBox("UpperCase", undefined, "onChangeUpperCase");
		this.addQuickSelectCheckBox();
		this.addConfirmCheckBox();
		this.addSpace();
		this.addMetaDataLongButton();
		this.addSpace();
		this.addResetLongButton();

	//--> ボタングループ
	this.addGroup("_button", column_opt);
		var create_btn	= this.addButton("_createLayers", menu_opt, "onClickCreate", undefined, undefined, "defaultElement");
		if(isCreateSampleColors()){
			create_btn.text	= this.infoData._createSampleColors;
		}
		this.addButton("_fillLayers", menu_opt, "onClickFill");
		this.addCancelButton(undefined, menu_opt);
		this.addApplyButton(undefined, menu_opt);
		//--> 表示スタック切り替え
		this.addGroup("_button/_stackMenu");
			this.addSpace();
			var stack_grp	= this.addStackChanger("_button/_stackMenu");


	/// イベントハンドラ
	var eventListener	= {};

	//{} 色設定ファイル一覧の更新
	var renewColorFiles	= function(){
		files_ddl.removeAll();
		var Main	= _config.data.Main;
		if(!Main.ColorFilePath || !new Folder(Main.ColorFilePath).exists){
			try{
				Main.ColorFilePath	= activeDocument.path.fsName;
			}catch(e){
				Main.ColorFilePath	= Folder.myDocuments.fsName;
			}
		}
		var folder	= new Folder(Main.ColorFilePath);
		var files	= FileUtil.getFileNamesOn(folder, COLOR_FILE_REG, _config.getListValue("Config.SubFolderDepth"));
		if(!files){
			files_ddl.add("item", "");
			editFile_etx.text	= "";
			_config.dispatchEvent("onClickCSVBrowser");
			return;
		}
		files.sort();
		//--? ファイル名フィルタにマッチするファイル名のみ選択
		var FileFilter	= Main.FileFilter;
		var root_reg	= /^[^\\\/]+$/;
		var name_reg	= /\..+?$/;
		var filter_reg	= FileFilter ? new RegExp(FileFilter.replace(OPTION_FILTER_REG, "")) : /./;
		var fileName;
		var max	= files.length - 1;
		if(max >= 0){
			for(var i = max; i >= 0; i--){
				fileName	= files[i].replace(name_reg, "");
				if(
					EXCLUDED_NAME_REG.test(fileName)
					||
					(!filter_reg.test(fileName) && !COLOR_WILD_FILTER_REG.test(fileName))
				){
					files.splice(i, 1);
				}
			}
		}
		files_ddl.setByArray(files);
		//--> 最終編集ファイルを選択
		selectLastFile();
	};

	//{} 最終編集ファイルを選択
	var selectLastFile	= function(){
		if(files_ddl.items.length > 0){
			var lastFileName	= StringUtil.escapeRegExp(_config.data.Main.ColorFile).replace(/\\\\|\\\//g, "[\\\\\\\/]");
			var strictlyFile_reg= new RegExp("^" + lastFileName + "$", "i");
			var file_reg		= new RegExp(lastFileName, "i");
			var files	= files_ddl.toArray();
			var len		= files.length;
			var f		= function(judge){
				for(i = 0; i < len; i++){
					if(judge(files[i])){
						files_ddl.selection	= i;
						return true;
					}
				}
				return false;
			};
			var i;
			//--? メタデータで指定された文字列にマッチするファイルを選択
			var FileFilter	= _config.data.Main.FileFilter;
			var selectOption= OPTION_ENABLE_REG.test(FileFilter) ? FileFilter.replace(OPTION_SELECT_REG, "").replace(OPTION_FILTER_REG, "") : FileFilter;
			var select_reg	= new RegExp(selectOption);
			if(
				(
					//(!) メタデータ指定にマッチするファイル
					selectOption
					&&
					(
						//(!) メタデータと前回編集ファイルの両方にマッチするファイル（厳密）
						f(function(file){return (select_reg.test(file) && strictlyFile_reg.test(file));})
						||
						//(!) メタデータと前回編集ファイルの両方にマッチするファイル
						f(function(file){return (select_reg.test(file) && file_reg.test(file));})
						||
						//(!) 最初に見つかったファイル
						f(function(file){return select_reg.test(file);})
					)
				)
				||
				(
					//(!) 前回使用したファイル（厳密）
					f(function(file){return strictlyFile_reg.test(file);})
					||
					//(!) 前回使用したファイル
					f(function(file){return file_reg.test(file);})
				)
			){
				return;
			}else{
				//(!) 該当ファイルがなければ先頭の物を選択
				files_ddl.selection	= 0;
			}
		}
	}

	//{} 色設定CSVに編集した値を適用
	var renewCSV	= function(){

		var color_csv	= _config.global.color_csv;

		if(!color_csv){
			return;
		}

		color_csv.setKeys(colorKeys_etx.text.split(SPLIT_COMMA_REG));
		//{a} 行データをレコード用配列に変換
		var filter	= function(line){
			return line.split(SPLIT_COMMA_REG);
		};

		//--> デフォルトアイテムをテーブルに適用
		var colors	= color_lbx.toArray(undefined, true);
		if(!colors.length){
			//(!) 万一編集状態が選択リストに反映されていなければ反映する
			colors	= colorEdit_lbx.toArray();
			color_lbx.setByArray(colors);
		}
		color_csv.setTable(colors, filter);

		//--> 入れ替え・抽出アイテムをレコードセットに適用
		color_csv.setRecordSet(color_lbx.toArray(_config.data.quickSelected && color_lbx.selection && true), filter);

	};


	//{?} 色設定CSVを更新保存：成否を返す
	var saveCSV	= function(){

		if(!_config.global.edited){
			return;
		}

		var color_csv	= _config.global.color_csv;

		if(!color_csv){
			throw new Error(ERROR_CSV_NOT_SAVED);
		}

		var Main		= _config.data.Main;
		if(Main.ColorFile){
			var recordSet_bak	= color_csv.recordSet;
			var path		= Main.ColorFilePath + "/" + Main.ColorFile;
			var folder		= FileUtil.provideFolder(path.replace(/[^\\\/]+$/, ""), _config.confirmed);
			//{--} カラーコードの先頭に"#"を付ける	※表計算ソフトで文字列として読み込まれるように	※スクリプト読み込み時に16進数用文字以外は自動削除される
			color_csv.setTable(color_csv.table, function(records){
				var column	= records.length;
				for(var i = BASE_INDEX; i < column; i++){
					records[i]	= records[i] ? records[i].replace(/^#?/, "#") : "";
				}
				return records;
			});
			if(_config.data.quickSelected){
				Main.ExtractColors	= color_lbx.toArray(true);
			}
			color_csv.setFile(path);
			return ScriptUtil.tries(SCRIPT_TITLE, color_csv.save, color_csv);
		}

	};


	///e{} リスト順変更イベント
	eventListener.onClickUpDown	= function(conf, item){
		conf.global.edited	= true;
	};

	///e{} リスト簡易選択ボタンイベント	//※【未完】
	eventListener.onClickQuickSelect	= function(conf, item){
//		extact_btn.visible	= !conf.data.quickSelected;
	};

	///e{} メタデータ取得ボタンイベント
	eventListener.onClickMetaData	= function(conf, item){
		_resonance.setConfigMetaData(conf.helpData._metaTitle, conf.data.Main.FileFilter);
	};

	///e{} CSV読み込みフォルダ選択ボタンイベント
	eventListener.onClickCSVBrowser	= function(conf, item){
		var basePath	= conf.data.Main.ColorFilePath;
		if(!new Folder(basePath).exists){
			basePath	= Folder.myDocuments;
		}
		var result_folder = Folder.selectDialog(conf.infoData.Main._browserInfo, basePath);
		if(result_folder){
			conf.data.Main.ColorFilePath	= result_folder.fsName;
			renewColorFiles();
		}
	};

	///e{} 色設定ファイルリストイベント
	eventListener.onChangeCSVList	= function(conf, item){
		if(conf.showed){
			color_lbx.extract_btn.onReset();
			conf.data.Main.ExtractColors	= [];
			color_lbx.selection	= null;
		}
		if(!item.selection || !item.selection.text){
			color_lbx.setByArray(null);
			colorEdit_lbx.setByArray(null);
			editFile_etx.text	= colorKeys_etx.text	= "";
			return;
		}
		var fileName	= item.selection.text.replace(/^ +$/, "");
		conf.data.Main.ColorFile	= fileName;
		if(fileName && new File(conf.data.Main.ColorFilePath + "/" + fileName).exists){
			//(!) フィルタリング後に該当ファイルがある場合
			conf.global.color_csv	= new CSVConnector(conf.data.Main.ColorFilePath + "/" + fileName);
			color_lbx.setByArray(
				 conf.global.color_csv.getTable()
				,function(item, row){
					var len	= item.length;
					for(var i = BASE_INDEX; i < len; i++){
						item[i]	= getRegularColorCode(item[i], _config.data.Config.UpperCase);
					}
					return item.join(JOIN_COMMA);
				}
				,true
			);
			colorEdit_lbx.setByArray(color_lbx.toArray());
			var info	= conf.infoData;
			var keys	= conf.global.color_csv.getKeys();
			colorKeys_etx.text	= color_etx.text	= keys.join(JOIN_COMMA);
			for(var i = 0; i <= MAX_EDIT_COLOR; i++){
				editKeys[i].text	= keys[i] ? keys[i] : "";
				editCodes[i].text	= "";
				editCodes[i].enabled	= Boolean(editKeys[i].text);
			}
			editFile_etx.text	= fileName;
		}else{
			//(!) フィルタリング後に該当ファイルがない場合
			if(conf.data.Main.FileFilter){
				conf.data.Main.FileFilter	= filter_etx.text	= "";
				renewColorFiles();
			}
		}
	};

	///e{} 抽出ボタンイベント
	eventListener.onClickExtract	= function(conf, item){
		if(item.isRecover){
			conf.data.Main.ExtractColors	= [];
		}else{
			conf.data.Main.ExtractColors	= color_lbx.toArray();
		}
	};

	///e{} 色キー編集イベント
	eventListener.onChangeEditKeys	= function(conf, item){
		if(conf.confirmAs(CONFIRM_CHANGE_KEYS) || !conf.data.confirmed){
			_config.global.edited	= true;
			conf.dispatchEvent("onSave");
			conf.dispatchEvent("onChangeCSVList", files_ddl);
		}else{
			item.text	= conf.global.color_csv.getKeys().join(JOIN_COMMA);
		}
	};

	///e{} 色編集リスト選択イベント
	eventListener.onChangeEditList	= function(conf, item){
		if(item.selection){
			var a	= item.selection.text.split(SPLIT_COMMA_REG);
			var len	= editCodes.length;
			for(var i = 0; i < len; i++){
				editCodes[i].text	= a[i] ? a[i] : "";
			}
		}
		conf.cancelApplyButton();
	};

	///e{} ファイル名編集イベント
	eventListener.onChangeFile	= function(conf, item){
		var Main	= conf.data.Main;
		if(conf.confirmAs(CONFIRM_CHANGE_FILE)){
			_config.global.edited	= true;
			var path		= item.text;
			var parentPath	= path.replace(/[^\\\/]+$/, "");
			var fileName	= path.replace(/^.*[\\\/]/, "");
			if(!COLOR_FILE_PREFIX_REG.test(fileName)){
				fileName	= DEFAULT_FILE_PREFIX + fileName;
			}
			if(!COLOR_EXTENSION_REG.test(fileName)){
				fileName	+= DEFAULT_EXTENSION;
			}
			if(parentPath){
				try{
					FileUtil.provideFolder(parentPath, conf.data.confirmed);
				}catch(e){
					item.text	= Main.ColorFile;
					return;
				}
			}
			Main.ColorFile	= item.text	= parentPath + fileName;
			conf.global.OtherFileSaved	= true;
			var file	= new File(Main.ColorFilePath + "/" + Main.ColorFile);
			var keys	= colorKeys_etx.text ? colorKeys_etx.text : DEFAULT_CSV_TEXT;
			if(!file.exists){
				file.open("w");
				file.write(keys);
				file.close();
			}
			conf.global.color_csv	= new CSVConnector(file.fsName);
			colorKeys_etx.text	= color_etx.text	= conf.global.color_csv.getKeys().join(JOIN_COMMA);
			conf.dispatchEvent("onSave");
			conf.dispatchEvent("onChangeCSVList", files_ddl);
		}else{
			item.text	= Main.ColorFile;
		}
	};

	///e{} 色編集コード選択イベント
	eventListener.onClickColorApply	= function(conf, item){
		var name	= editCodes[0].text;
		if(!name){
			//(!) 名前が指定されていなければキャンセル
			return;
		}
		var s	= "";
		var len	= conf.global.color_csv.getColumns();
		for(var i = 0; i < len; i++){
			s	+= (i == 0 ? "" : JOIN_COMMA) + editCodes[i].text;
		}
		if(colorEdit_lbx.selection){
			//(!) 適用
			colorEdit_lbx.selection.text	= s;
		}else{
			//(!) 追加
			var overlap_reg	= new RegExp("^(" + name + ")[ ]*,");
			var items	= colorEdit_lbx.items;
			var len2	= items.length;
			if(len2 == 1 && (/^ *$/).test(items[0].text)){
				colorEdit_lbx.removeAll();
			}else{
				for(var j = 0; j < len2; j++){
					if(overlap_reg.test(items[j].text)){
						//(!) 既に同名色がある場合
						return;
					}
				}
			}
			colorEdit_lbx.selection	= colorEdit_lbx.add("item", s);
		}
		color_lbx.setByArray(colorEdit_lbx.toArray(), undefined, true);
		conf.enableApplyButton();
		conf.global.edited	= true;
	};

	///e{} 色編集コード削除イベント
	eventListener.onClickColorRemove	= function(conf, item){
		color_lbx.setByArray(colorEdit_lbx.toArray(), undefined, true);
		conf.enableApplyButton();
		conf.global.edited	= true;
	};

	///e{} レイヤー生成ボタンイベント
	eventListener.onClickCreate	= function(conf, item){
		if(isCreateSampleColors()){
			//(!) テンプレートからの色設定レイヤー生成
			var confirmMessage	= CONFIRM_CREATE_BY_TPL + activeDocument.name + CONFIRM_START_SUFFIX;
		}else{
			//(!) 通常のレイヤー生成
			var confirmMessage	= CONFIRM_CREATE_LAYERS + targetParent.name + CONFIRM_START_SUFFIX;
		}
		if(conf.confirmAs(confirmMessage)){
			conf.data.currentStack	= INDEX_DEFAULT_STACK;
			conf.global.isCreated	= true;
			conf.close(true);
		}
	};

	///e{} レイヤー塗り潰しボタンイベント
	eventListener.onClickFill	= function(conf, item){
		if(conf.confirmAs(CONFIRM_FILL_LAYERS + targetParent.name + CONFIRM_START_SUFFIX)){
			conf.global.isCreated	= false;
			conf.close(true);
		}
	};

	///e{} ファイルフィルタ編集イベント
	eventListener.onChangeFileFilter	= function(conf, item){
		renewColorFiles();
	};

	///e{} ファイル検索深度変更イベント
	eventListener.onChangeSubFolderDepth	= function(conf, item){
		renewColorFiles();
	};

	///e{} レイヤーセット自動生成編集イベント
	eventListener.onChangeIntoLayerSet	= function(conf, item){
		notLayerSet_grp.enabled	= item.value;
	};

	///e{} ファイルフィルタ編集イベント
	eventListener.onChangeUpperCase	= function(conf, item){
		conf.dispatchEvent("onChangeCSVList", files_ddl);
	};

	///e{} 表示時イベント
	eventListener.onShow	= function(conf, item){

		var Main	= conf.data.Main;

		//--> 最終編集ファイルを選択
		selectLastFile();

		//--? カラーリストのフィルタ状況を再現
		var ExtractColors	= Main.ExtractColors;
		if(!conf.data.Config.AutoFilter || !ExtractColors.length){
			return;
		}
		var extract_reg	= new RegExp(StringUtil.escapeRegExpOnArray(ExtractColors, "|"));
		var items	= color_lbx.items;
		var len		= items.length;
		for(var i = 0; i < len; i++){
			items[i].selected	= extract_reg.test(items[i].text);
		}
		if(!conf.data.quickSelected){
			color_lbx.onExtractListItem();
		}

	};

	///e{} 保存時イベント
	eventListener.onSave	= function(conf, isClose){

		//--? CSVデータをダイアログ設定と同期
		renewCSV();
		if(_protected || !conf.global.color_csv){
			return;
		}

		//--? CSVファイルも保存
		saveCSV()

		//--> 色設定ファイルリスト更新
		if(conf.global.OtherFileSaved){
			conf.global.OtherFileSaved	= false;
			renewColorFiles();
		}

		//--? フィルタリング情報を保存するか判定
		conf.global.lastFilter	= conf.data.Main.FileFilter;
		if(metaData_str && conf.data.Main.FileFilter == metaData_str && conf.global.firstFilter != metaData_str){
			//(!) メタデータによって強制的に上書きされたフィルタとみなして無効判定
			conf.data.Main.FileFilter	= conf.global.firstFilter;
		}

	};

	///e{} エラー時イベント
	eventListener.onError	= function(conf, item, e, eventName){
		alert("<onError>\n"+"\n["+eventName+ "]\n" +item+ "\n\n" +e);
	};


	///e{} 色見本ファイルを直接変換	//※【隠し】
	this.addButton("_convertcSCV", {bounds:[0,0,0,0]}, "onClickConvertCSV", "&:conv");
	eventListener.onClickConvertCSV	= function(conf, item){
		result	= prompt("変換ファイル名", (conf.data.convertFileName ? conf.data.convertFileName : ""));
		if(result){
			conf.data.convertFileName	= result;
			conf.save();
			var file	= new File(conf.data.Main.ColorFilePath + "/" + result + ".csv");
			if(file.exists){
				conf.global.trans_csv	= new CSVConnector(file.fsName);
				convertCSV();
				conf.close(false);
			}
		}
	};


	//--> イベントリスナーを登録
	this.setListener(eventListener);

	//--> 色設定ファイルリスト更新
	renewColorFiles();

	//--? 直実行専用処理
	if(this.data.directly){
		this.dispatchEvent("onChangeCSVList", files_ddl);
	}

  };

};


///{} 色見本ファイルを直接変換	//※【隠し】
function convertCSV(conv_csv){

	var base_csv	= _config.global.color_csv;
	var table	= base_csv.table;

	var convertColor	= function(baseRecord){
		var len	= baseRecord.length;
		for(var i = BASE_INDEX; i < len; i++){
			if(baseRecord[i]){
				baseRecord[i]	= "#" + transColorCode("0x" + baseRecord[i].replace(/^#/, ""), baseRecord[NAME_INDEX], base_csv.keys[i]).toString(16);
			}
		}
		return baseRecord;
	};

	base_csv.each(function(record, row){
		table[row]	= convertColor(record);
	});

	var convID	= _config.global.trans_csv.fileName.replace(/：.+/, "");
	var savePath	= base_csv.filePath.replace(/[^\\\/]+$/, "") + "/" + convID;
	FileUtil.provideFolder(savePath);

	base_csv.save(savePath + "/" + base_csv.fileName + "（" + convID + "）.csv");

};


///{?} 色見本作成状態か
function isCreateSampleColors() {

	var activeLayer	 = activeDocument.activeLayer;
	return (
		(activeLayer.typename == "LayerSet" && TPL_LAYER_SET_REG.test(activeLayer.name))
		||
		(activeLayer.parent.typename == "LayerSet" && TPL_LAYER_SET_REG.test(activeLayer.parent.name))
	);

};


///{} 色設定表に基づいてレイヤー生成
function createLayers() {

	var targetParent	= _config.global.targetParent;

	//--> マスクの描画色を適用しないよう一時レイヤーを作成
	createTemporaryLayer();

	//--> 色変換データ読み込み
	loadTransData();

	//> レイヤー生成先
	var layerSets	= targetParent.layerSets;
	var artLayers;
	var newLayerSet;

	var IntoLayerSet		= _config.data.Config.IntoLayerSet;
	var CreateLayerSetAmount	= _config.getListValue("Config.CreateLayerSetAmount");
//	var setForegroundColor	= ColorUtil.setForegroundColor;
	var doEventAction		= Resonance.doEventAction;

	var created	= false;

	var color_csv	= _config.global.color_csv;
	var keys		= color_csv.getKeys();
	var columns		= color_csv.getColumns();

	//{--} レコードセットのデータをひとつずつ取り出して処理
	var name, sectionName, column;
	color_csv.eachOnReverse(function(record, row){

		name	= record[NAME_INDEX];

		//--? 色設定の名前かベース色が存在しなければスキップ
		if(!name || !record[BASE_INDEX]){
			return;	//continue
		}

		//--> グループ毎にレイヤーセット追加
		var recordLength	= 0;
		for(var i = BASE_INDEX; i < record.length; i++){
			if(record[i]){
				recordLength++;
			}
		}
		if(IntoLayerSet && (recordLength >= CreateLayerSetAmount)){
			//(!) 色数が一定以上の場合のみレイヤーセット追加
			newLayerSet	= layerSets.add();
			newLayerSet.name	= name;
			activeDocument.activeLayer	= newLayerSet;
			doEventAction(ACTION_PARENT_LAYER_SET);
			doEventAction(ACTION_FILL_LAYER_PREFIX + name + ACTION_NEW_PARENT_LAYER_SUFFIX);
		}else if(targetParent.typename != "Document"){
			activeDocument.activeLayer	= targetParent;
		}

		//--> レイヤーセット内に基本レイヤーを追加して塗り潰し
		if(setForegroundColor(record[BASE_INDEX])){
			created = true;
			if(doEventAction(ACTION_NEW_PARENT_LAYER)){
				doEventAction(ACTION_FILL_LAYER);
			}else{
				createParentLayer();
			}
			doEventAction(ACTION_FILL_LAYER_PREFIX + name + ACTION_NEW_LAYER_SUFFIX);
			doEventAction(ACTION_FILL_LAYER_PREFIX + name + ACTION_FILL_LAYER_SUFFIX);
			doEventAction(ACTION_FILL_LAYER_PREFIX + ACTION_PREFIX_HEAD + name.charAt(0) + ACTION_NEW_LAYER_SUFFIX);
			activeDocument.activeLayer.name	= FILL_PREFIX + name;
		}

		for(column = BASE_INDEX + 1; column < columns; column++){
			created = true;
			if(record[column] && setForegroundColor(record[column])){
				sectionName	= keys[column];
				if(doEventAction(ACTION_NEW_CHILD_LAYER)){
					doEventAction(ACTION_FILL_LAYER);
				}else{
					createChildLayer();
				}
				doEventAction(ACTION_FILL_LAYER_PREFIX + sectionName + ACTION_NEW_LAYER_SUFFIX);
				doEventAction(ACTION_FILL_LAYER_PREFIX + sectionName + ACTION_FILL_LAYER_SUFFIX);
				doEventAction(ACTION_FILL_LAYER_PREFIX + name + ACTION_PARENT_DELIMITER + sectionName + ACTION_NEW_LAYER_SUFFIX);
				doEventAction(ACTION_FILL_LAYER_PREFIX + name + ACTION_PARENT_DELIMITER + sectionName + ACTION_FILL_LAYER_SUFFIX);
				activeDocument.activeLayer.name	= FILL_PREFIX + keys[column];
			}
		}

	});

	//--> 一時レイヤーを破棄
	removeTemporaryLayer();

	//--> 完了通知
	if(created){
		//(!) 正常に生成された場合
		_config.alertAs(RESULT_CREATE_LAYERS);
	}else{
		//(!) 生成レイヤーがなかった場合
		_config.alertAs(RESULT_NOT_CREATE_LAYERS, Resonance.title.ERROR, true);
	}

};


///{} テンプレートレイヤーセットを元にレイヤーを生成する（色見本の作成用）
function createLayersByTemplate(tplLayerSet) {

	tplLayerSet.visible	= true;

	activeDocument.selection.deselect();

	var baseLayerSets	= tplLayerSet.parent.layerSets;

	var getLayerByName	= LayerUtil.getLayerByName;
	var move			= LayerUtil.move;

	var apply_reg		= new RegExp(FILL_REG_PREFIX);
	var extract_reg		= new RegExp("(" + FILL_REG_PREFIX + "|[ 　]+.*)", "g");
	var selection		= activeDocument.selection;

	//> 複製後の移動量
	var xMove	= parseInt(tplLayerSet.name.replace(TPL_X_MOVE_REG, ""));
	var yMove	= parseInt(tplLayerSet.name.replace(TPL_Y_MOVE_REG, ""));

	//{--} レコードセットのデータをひとつずつ取り出して処理
	var color_csv	= _config.global.color_csv;
	color_csv.each(function(record, row){

		//--> テンプレートレイヤーセットを複製してグループ名を適用
		var layerSet	= tplLayerSet.duplicate();
		layerSet.name	= record[NAME_INDEX];
		var artLayers	= layerSet.artLayers;
		var len			= artLayers.length;
		for(var i = 0; i < len; i++){
			artLayer	= artLayers[i];
			artLayer.name	= artLayer.name.replace(DELETE_NAME_REG, "");
			if(apply_reg.test(artLayer.name)){
				//--? 色設定非対応レイヤーは隠す
				if(!color_csv.getByKey(artLayer.name.replace(extract_reg, ""), row)){
					artLayer.visible	= false;
				}
			}
		}

		//--> ベースレイヤーにベース名適用
		var name	= record[NAME_INDEX];
		try{
			artLayer		= getLayerByName(artLayers, TPL_BASE_REG);
			artLayer.name	= FILL_PREFIX + name;
		}catch(e){}

		//--> テキストレイヤーにグループ名適用
		try{
			artLayer		= getLayerByName(artLayers, TPL_NAME_REG);
			if(artLayer.textItem){
				artLayer.textItem.contents	= artLayer.textItem.contents.replace(TPL_NAME_REG, name);
			}
		}catch(e){}

		//{--} テンプレート複製後の移動用	※レイヤーのtranslate()ではpixel指定の移動がうまくいかないので
		activeDocument.activeLayer	= layerSet;
		move(xMove * row, yMove * row);

	});

	//--> 色適用
	fillLayers(activeDocument, RESULT_BY_TPL, true);

	tplLayerSet.visible	= false;

};


///{} 色設定表に基づいてレイヤー塗り潰し
function fillLayers(targetParent, resultMessage, isTemplate) {
//var sw	= new Stopwatch();sw.start();
	//--> 現在のレイヤー状態を記憶
	var currentLayer	= activeDocument.activeLayer;
	activeDocument.layerComps.add(_resonance.backupLayerCompName, "", false, false, true);	//※なぜか戻り値で違うレイヤーカンプが来てしまう
	var currentComp		= activeDocument.layerComps.getByName(_resonance.backupLayerCompName);

	//--> マスクの描画色を適用しないよう一時レイヤーを作成
	createTemporaryLayer();

	//--> 色変換データ読み込み
	loadTransData();

	//> 塗り潰しレイヤー判定用正規表現
	var fill_reg	= new RegExp(FILL_REG_PREFIX + ".+", "i");	//> 塗り潰し対象レイヤー
	var name_reg	= new RegExp(".*" + FILL_REG_PREFIX);		//> 塗り潰し記号を除外してベース名を取得
	var keys_reg	= getFillKeysReg();							//> 塗り潰し対象全種類名
	var keyRegs		= getFillKeyRegs();							//> 塗り潰し対象個別種類名

	//{--} 全レイヤーを調べて規定色に対応するレイヤーなら塗り潰し
	var result;
	var filled		= false;
	//r{} レイヤーコレクション毎に塗り潰し適用
	var fill	= function(layers){
		var layer;
		var sameLayers	= [];
		var len	= layers.length;
		for(var i = 0; i < len; i++){
			layer	= layers[i];
			if(layer.typename == "LayerSet"){
				fill(layer.layers);
			}else if(fill_reg.test(layer.name)){
				sameLayers.unshift(layer);
				result	= ifApplyNameThenFill(sameLayers, fill_reg, name_reg, keys_reg, keyRegs, isTemplate);
			}
			if(!filled && result){
				filled	= true;
			}
		}
	};
	fill(targetParent.layers);

	//--> 実行前のレイヤー状態を復元
	removeTemporaryLayer();
	activeDocument.activeLayer	= currentLayer;
	currentComp.apply();
	currentComp.remove();
//sw.stop();
	//--> 完了通知
	if(filled){
		_config.alertAs(resultMessage ? resultMessage : RESULT_FILL_LAYERS);
	}else{
		_config.alertAs(RESULT_NOT_FILL_LAYERS, Resonance.title.ERROR, true);
	}

};


///{f} 塗り潰し対象全種類名
function getFillKeysReg() {

	return new RegExp(FILL_REG_PREFIX + "(" + _config.global.color_csv.keys.join("|").replace(/^.*?\|.*?\|/, "") + ")", "i");

};


///{a} 塗り潰し対象個別種類名
function getFillKeyRegs() {

	var a		= [];
	var keys	= _config.global.color_csv.getKeys();
	var len		= keys.length;
	for(var i = BASE_INDEX + 1; i < len; i++){
		a[i]	= new RegExp(FILL_REG_PREFIX + "(" + keys[i] + ")([ 　]|$)", "i");
	}

	return a;

};


///{} 規定色と対応する名前のレイヤーを塗り潰す
function ifApplyNameThenFill(sameLayers, fill_reg, name_reg, keys_reg, keyRegs, isTemplate) {

	var result		= false;

	var doEventAction	= Resonance.doEventAction;

	var fill	= function(){
		activeDocument.selection.fill(foregroundColor, undefined, undefined, true);
	};

	var name, sectionName;

	var layer		= sameLayers[0];
	var parentLayer	= layer.parent;
	var overLayer;
	var overName;
	var resultChildren	= false;

	//> レイヤー名の空白以降は判定から除外
	var match_reg	= new RegExp("(^|\\|)" + layer.name.replace(name_reg, "").replace(/[ 　].*/g, "") + "(\\||$)");
	var layerLength	= sameLayers.length;

	//{--} レコードセットのデータをひとつずつ取り出して処理
	var color_csv	= _config.global.color_csv;
	var keys		= color_csv.getKeys();
	var columns		= color_csv.getColumns();
	color_csv.each(function(record, row){

		name	= record[NAME_INDEX];

		//--? 名前がマッチしなければスキップ
		if(!match_reg.test(name)){
			return;	//continue
		}

		//--? 基本色塗り潰し
		if(setForegroundColor(record[BASE_INDEX], name, keys[BASE_INDEX])){
			result	= true;
			activeDocument.activeLayer	= layer;
			if(isTemplate){
				fill();
			}else{
				if(!doEventAction(ACTION_FILL_LAYER)){
					executeFillLayer();
				}
				doEventAction(ACTION_FILL_LAYER_PREFIX + name + ACTION_FILL_LAYER_SUFFIX);
			}
		}

		//--? このレイヤーより上にベース以外の対応レイヤーがあれば適宜処理
		for(var i = 1; i < layerLength; i++){
			overLayer	= sameLayers[i];
			if(!overLayer || parentLayer != overLayer.parent){
				break;
			}
			overName	= overLayer.name;
			resultChildren	= true;
			//--? 自色の塗り潰し対象サブレイヤーを順次塗り潰していく
			for(column = BASE_INDEX + 1; column < columns; column++){
				if(fill_reg.test(overName)){
					//(!) 塗り潰し対象レイヤー
					if(keys_reg.test(overName)){
						//(!) 塗り潰し対象サブレイヤー
						if(record[column] != undefined && keyRegs[column].test(overName) && setForegroundColor(record[column], name, keys[column])){
							//(!) 現在の塗り潰し対象サブレイヤー
							result	= true;
							sectionName	= keys[column].replace(REG_DELIMITER_REG, "");
							activeDocument.activeLayer	= overLayer;
							if(isTemplate){
								fill();
							}else{
								if(!doEventAction(ACTION_FILL_LAYER)){
									executeFillLayer();
								}
								doEventAction(ACTION_FILL_LAYER_PREFIX + sectionName + ACTION_FILL_LAYER_SUFFIX);
								doEventAction(ACTION_FILL_LAYER_PREFIX + name + ACTION_PARENT_DELIMITER + sectionName + ACTION_FILL_LAYER_SUFFIX);
							}
						}
					}else{
						//(!) 塗り潰し対象サブレイヤー以外の場合
						resultChildren	= false;
					}
				}
			}
			//--? 他色の塗り潰し対象レイヤーにまで来たらキャンセル
			if(!resultChildren){
				break;
			}
		}

	});

	return result;

};


///{} 描画色をカラーコードで指定されたものに変更
function setForegroundColor(colorCode, name, key){

	colorCode	= Number("0x" + colorCode);

	if(_config.global.trans_csv){
		colorCode	= transColorCode(colorCode, name, key);
	}

	return ColorUtil.setForegroundColor(colorCode, true);

};


///{#} カラーコードをファイル指定データに基づいて変換して返す
function transColorCode(colorCode, name, key){

	var red		= colorCode >> 16;
	var green	= (colorCode - (red << 16)) >> 8;
	var blue	= colorCode - (red << 16) - (green << 8);

	//--> 対応する名前の変換レコードを取得（なければ汎用無名レコードを取得）

	var match_reg	= new RegExp("(^|\\|)" + name + "(\\||$)");
	var keys	= _config.global.trans_csv.getKeys();
	var selects;
	_config.global.trans_csv.each(function(record, row){
		if(!record[NAME_INDEX] && !select){
			selects	= record;
		}else if(match_reg.test(record[NAME_INDEX])){
			selects	= record;
		}
	});

	var select, temp;
	var len	= keys.length;
	for(var i = BASE_INDEX; i < len; i++){
		if(selects[i]){
			temp	= selects[i];
		}
		if(key == keys[i]){
			select	= selects[i];
			break;
		}
	}
	if(!select){
		if(!temp){
			return colorCode;
		}
		select	= temp;
	}

	var transRGB	= select.split(COLOR_TRANS_SPLITER);
	for(var j = 0; j < 3; j++){
		if(!transRGB[j]){
			transRGB[j]	= transRGB[j - 1];
		}
	}

	//{#} カラーコードを指定の倍率で変換して返す
	var trans	= function(color, mul){
		var n	= color * Number(mul);
		if(n > 0xFF){
			n	= 0xFF;
		}else if(n < 0){
			n	= 0;
		}
		return n;
	};

	return	(trans(red, transRGB[0]) << 16) +
			(trans(green, transRGB[1]) << 8) +
			 trans(blue, transRGB[2]);

};


///{} マスクのグレースケール描画色を適用しないよう一時レイヤーを作成	//※【未完】
function createTemporaryLayer() {
return;
	var tempLayer	= _config.global.tempLayer	= activeDocument.artLayers.add();
	tempLayer.name	= _resonance.temporaryLayerName;
	activeDocument.activeLayer	= tempLayer;

	//--> 空レイヤーだと後でレイヤーを生成した時に乗っ取られるので1pixelだけ埋めておく
	var selection	= activeDocument.selection;
	selection.select([[0, 0], [1, 0], [1, 1], [0, 1], [0, 0]]);
	selection.fill(foregroundColor);
	selection.deselect();

};


///{} 一時レイヤーを破棄	//※【未完】
function removeTemporaryLayer() {
return;

	_config.global.tempLayer.remove();
	delete _config.global.tempLayer;

};


///{?} 色変換データ取得
function loadTransData() {

	var FileFilter	= _config.global.lastFilter;

	var transOption	= OPTION_ENABLE_REG.test(FileFilter) ? FileFilter.replace(OPTION_TRANSFORM_REG, "") : FileFilter;

	var path	= _config.data.Main.ColorFilePath + "/" + transOption;
	var file;
	var len		= EXTENSION_LIST.length;
	for(var i = 0; i < len; i++){
		file	= new File(path + EXTENSION_LIST[i]);
		if(file.exists){
			break;
		}
	}
	if(!file.exists){
		return false;
	}

	_config.global.trans_csv	= new CSVConnector(file.fsName);

	return true;

};

function createParentLayer() {

	executeCreateFillLayer();
	ColorUtil.selectRGBChannel();
	executeFillLayer();

};

function createChildLayer() {

	executeCreateFillLayer();
	ColorUtil.selectRGBChannel();
	executeFillLayer();
	executeGroupLayer();

};

function executeCreateFillLayer() {
	var idMk = charIDToTypeID( "Mk  " );
		var desc0 = new ActionDescriptor();
		var idNull = charIDToTypeID( "null" );
			var ref0 = new ActionReference();
			var idContentLayer = stringIDToTypeID( "contentLayer" );
			ref0.putClass( idContentLayer );
		desc0.putReference( idNull, ref0 );
		var idUsing = charIDToTypeID( "Usng" );
			var desc1 = new ActionDescriptor();
			var idType = charIDToTypeID( "Type" );
				var desc2 = new ActionDescriptor();
				var idClr = charIDToTypeID( "Clr " );
					var desc3 = new ActionDescriptor();
					var idRd = charIDToTypeID( "Rd  " );
					desc3.putDouble( idRd, 0.000000 );
					var idGrn = charIDToTypeID( "Grn " );
					desc3.putDouble( idGrn, 0.000000 );
					var idBl = charIDToTypeID( "Bl  " );
					desc3.putDouble( idBl, 0.000000 );
				var idRGBC = charIDToTypeID( "RGBC" );
				desc2.putObject( idClr, idRGBC, desc3 );
			var idSolidColorLayer = stringIDToTypeID( "solidColorLayer" );
			desc1.putObject( idType, idSolidColorLayer, desc2 );
		var idContentLayer2 = stringIDToTypeID( "contentLayer" );
		desc0.putObject( idUsing, idContentLayer2, desc1 );
	executeAction( idMk, desc0, DialogModes.NO );
	var idInvr = charIDToTypeID( "Invr" );
	executeAction( idInvr, undefined, DialogModes.NO );
};

function executeFillLayer() {
	var idFl = charIDToTypeID( "Fl  " );
		var desc = new ActionDescriptor();
		var idUsng = charIDToTypeID( "Usng" );
		var idFlCn = charIDToTypeID( "FlCn" );
		var idFrgC = charIDToTypeID( "FrgC" );
		desc.putEnumerated( idUsng, idFlCn, idFrgC );
	executeAction( idFl, desc, DialogModes.NO );
};

function executeGroupLayer() {
	var idGrpL = charIDToTypeID( "GrpL" );
		var desc = new ActionDescriptor();
		var idNull = charIDToTypeID( "null" );
			var ref = new ActionReference();
			var idLyr = charIDToTypeID( "Lyr " );
			var idOrdn = charIDToTypeID( "Ordn" );
			var idTrgt = charIDToTypeID( "Trgt" );
			ref.putEnumerated( idLyr, idOrdn, idTrgt );
		desc.putReference( idNull, ref );
	executeAction( idGrpL, desc, DialogModes.NO );
};

